import { Injectable } from '@nestjs/common';
import {
  EventTopics,
  columnUniques,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { SeasonPeriodEntity } from '../../entities/season-period.entity';
import { SeasonPeriodModel } from '../../../data/models/season-period.model';
import { BaseCreateManager } from 'src/core/modules/domain/usecase/managers/base-create.manager';
import { SeasonPeriodCreatedEvent } from '../../entities/event/season-period-created.event';

@Injectable()
export class CreateSeasonPeriodManager extends BaseCreateManager<SeasonPeriodEntity> {
  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get uniqueColumns(): columnUniques[] {
    return [];
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: SeasonPeriodCreatedEvent,
        data: {
          ...this.data,
        },
      },
    ];
  }

  get entityTarget(): any {
    return SeasonPeriodModel;
  }
}
